%The project of calculating the changes and drawing the non-permanent flow
%profile using the Sarrabh method
clear all
clc
%input
L=20000
b=14
Q0=2
y0=0.192
s0=0.001
n=0.014
time=140
N=160

%Calculations
time=time*60
g=9.81;
A0=b*y0;
R0=b*y0/(b+2*y0);
V0=Q0/A0;
a=sqrt(g*y0)+V0;
T=L/a;
Dx=L/(N-1)
Dt=floor((Dx/a)/10)*10-20
%Calculate the number of loops
FT=ceil(time/Dt);
%Define Variable Matrix for Q,Y,R,V
Q=zeros(FT);Y=zeros(N,FT);V=zeros(N,FT);R=zeros(N,FT);courant=zeros(FT);
%Calculate initial Courant number
courant(1)=Dx/a;
%%Definition of vector X
X=linspace(0,L,N);
%Y,R,Q,V at time=0
Y(1:N,1)=y0;
R(1:N,1)=R0;
Q(1)=Q0;
V(1:N,1)=V0;
%Define y as variable of saint venant equation
syms y
t=0;

%Loop for times of calculations
for j=2:FT
t=t+Dt;
%Check and calculate the amount of Q for any time
if t<=1200
Q(j)=Q0+((Q0*2)/1200)*t;
elseif t==1200:3600
Q(j)=-Q0/1600*(t-1200)+(3*Q0);
else
Q(j)=Q0+1;
end
%Calculate amount of Y,V,R at Upstream condition
ys=Y(2,j-1);
A=(b*ys);
P=(b+2*ys);
Vs=V(2,j-1);
%Define the saint venant equation and solve it
M=solve(Q(j)/(b*y)-Vs-sqrt(g/ys)*(y-ys)+g*((Q(j))^2*n^2/(A^2*(A/P)^(4/3))-s0)*Dt);
if double(M(1,1))>0
Y(1,j)=M(1,1);
else
Y(1,j)=M(2,1);
end
R(1,j)=(b*Y(1,j)/(b+2*Y(1,j)));
V(1,j)=Q(j)/(b*Y(1,j));
 %Loop for calculating data at points between Upstram and Downstream conditions
 for i=2:N-1
Y(i,j)=Y(i,j-1)-(Dt/(2*Dx))*(V(i,j-1)*(Y(i+1,j-1)-Y(i-1,j- ...
1))+Y(i,j-1)*(V(i+1,j-1)-V(i-1,j-1)));
R(i,j)=(b*Y(i,j)/(b+2*Y(i,j)));
sf=V(i,j-1)^2*n^2/(R(i,j)^(4/3));
V(i,j)=V(i,j-1)-V(i,j-1)*((V(i+1,j-1)-V(i-1,j-1))*Dt/(2*Dx))- ...
g*Dt*(Y(i+1,j-1)-Y(i-1,j-1))/(2*Dx)+g*Dt*(s0-sf);
 end
 %Calculate amount of Y,V,R at Downstream condition
Y(N,j)=(V(N-1,j)*Y(N-1,j)*b/(14*sqrt(g)))^(2/3);
V(N,j)=(14*sqrt(g)*Y(N,j)^(1.5))/(b*Y(N,j));
R(N,j)=(b*Y(N,j)/(b+2*Y(N,j)));
%Calculate Courant number for any time
courant(j)= max(Dx/(sqrt(g*Y(:,j))+V(:,j)));
j
disp('courant')
courant(j)
end

xmax=0.4
for i=1:3:20
plot(X(:),Y(:,i),'-b','LineWidth',1)
title(' X-Y Graph for special times of computations ')
xlabel(' X = 0 ~ 20000 (m)')
ylabel(' Y (m)')
box on
axis([0 L 0 xmax])
hold on
end
ff=floor(FT/2);
ee=floor(FT/2+30);
for i=ff:3:ee
plot(X(:),Y(:,i),':k','LineWidth',1)
title(' X-Y Graph for special times of computations ')
xlabel(' X = 0 ~ 20000 (m)')
ylabel(' Y (m)')
box on
axis([0 L 0 xmax])
hold on
end
ff=floor(FT-30);
ee=floor(FT);
for i=ff:3:ee
plot(X(:),Y(:,i),'--r','LineWidth',1)
title(' X-Y Graph for special times of computations ')
xlabel(' X = 0 ~ 20000 (m)')
ylabel(' Y (m)')
box on
axis([0 L 0 xmax])
hold on
end